# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`fips`](#fips): This module manages the enabling and disabling of FIPS on a system It will set the kernel boot parametes and install/remove the dracut packag

## Classes

### <a name="fips"></a>`fips`

This module manages the enabling and disabling of FIPS on a system
It will set the kernel boot parametes and install/remove the dracut packages
and rebuild initramfs images.

Changing the FIPS status of a system changes the cryptographic modules used.
This can affect existing keys and certificates and make them unusable.  Make
sure these effects are understood before changing the status.

NOTE: The preferred method yo set FIPS mode consistently across ALL
ALL SIMP modules is to set `simp_options::fips` to `true` in Hiera.

#### Parameters

The following parameters are available in the `fips` class:

* [`fipscheck_package_name`](#-fips--fipscheck_package_name)
* [`enabled`](#-fips--enabled)
* [`aesni`](#-fips--aesni)
* [`dracut_ensure`](#-fips--dracut_ensure)
* [`fipscheck_ensure`](#-fips--fipscheck_ensure)
* [`nss_ensure`](#-fips--nss_ensure)

##### <a name="-fips--fipscheck_package_name"></a>`fipscheck_package_name`

Data type: `String`

The name of the package that provides the
fipscheck binary

##### <a name="-fips--enabled"></a>`enabled`

Data type: `Boolean`

If FIPS should be enabled or disabled on the system.

* NOTE: Given the dangerous nature of FIPS unexpectedly being activated on
  a system, this module mirrors the existing status of FIPS on the system
  to which it is applied.

Default value: `simplib::lookup('simp_options::fips', { 'default_value' => $facts['fips_enabled']})`

##### <a name="-fips--aesni"></a>`aesni`

Data type: `Boolean`

This parameter indicates whether the system uses the
Advanced Encryption Standard New Instructions set.

Default value: `($facts['cpuinfo'] and member($facts['cpuinfo']['processor0']['flags'], 'aes')`

##### <a name="-fips--dracut_ensure"></a>`dracut_ensure`

Data type: `String`

The ensure status of the dracut-fips and
dracut-fips-aesni packages

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

##### <a name="-fips--fipscheck_ensure"></a>`fipscheck_ensure`

Data type: `String`

The ensure status of the fipscheck package

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

##### <a name="-fips--nss_ensure"></a>`nss_ensure`

Data type: `String`

The ensure status of the nss package

Default value: `simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })`

